<?php

namespace DsbNext\Controllers;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;

class DashboardGUController{
    
    protected $crudService;
    
    public function __construct($connection, $environment, $util, $crudService) {
        $this->crudService	= $crudService;
        $this->connection      = $connection;
        $this->environment     = $environment;
        $this->util            = $util;
    }
    
    public function daysOfStockGU(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'CDOPERADOR', 'DTPROCESSA', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);
        $filter = $request->getFilterCriteria()->getConditions();
        $data = $this->crudService->getFilteredDataSet('daysOfStockGU', array_merge($conditions, $filter))->getRows();
		$response->addDataSet(new DataSet("daysOfStockGU", $data));
    }
    
    public function extraRequestGU(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'DTPROCESSA', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);

        $data = $this->crudService->getFilteredDataSet('extraRequestGU', $conditions)->getRows();
		$response->addDataSet(new DataSet("extraRequestGU", $data));
    }
    
    public function consumptionDiversionGU(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'DTPROCESSA', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);
        $filter = $request->getFilterCriteria()->getConditions();
        
        $data = $this->crudService->getFilteredDataSet('consumptionDiversionGU', array_merge($conditions, $filter))->getRows();
		$response->addDataSet(new DataSet("consumptionDiversionGU", $data));
    }
    
    public function processingDateGU(Request\Filter $request, Response $response) {
        $processingDate = $this->util->getDateProc();
        $data = [array('VALUE' => $processingDate)];
		$response->addDataSet(new DataSet("processingDateGU", $data));
    }
    
    public function nextMenuReleaseGU(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL'];
        $conditions = $this->util->prepareConditions($params);

        $data = $this->crudService->getFilteredDataSet('nextMenuReleaseGU', $conditions)->getRows();
		$response->addDataSet(new DataSet("nextMenuReleaseGU", $data));
    }
    
    public function adjustmentValueGU(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'DTPROCESSA', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);

        $data = $this->crudService->getFilteredDataSet('adjustmentValueGU', $conditions)->getRows();
		$response->addDataSet(new DataSet("adjustmentValueGU", $data));
    }
    
    public function daysMenuApprovalGU(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);

        $data = $this->crudService->getFilteredDataSet('daysMenuApprovalGU', $conditions)->getRows();
		$response->addDataSet(new DataSet("daysMenuApprovalGU", $data));
    }
    
    public function financialImpactGU(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);
        $filter = $request->getFilterCriteria()->getConditions();

        $data = $this->crudService->getFilteredDataSet('financialImpactGU', array_merge($conditions, $filter))->getRows();
		$response->addDataSet(new DataSet("financialImpactGU", $data));
    }
    
    public function pendingReleasesGU(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);
        $filter = $request->getFilterCriteria()->getConditions();

        $data = $this->crudService->getFilteredDataSet('pendingReleasesGU', array_merge($conditions, $filter))->getRows();
		$response->addDataSet(new DataSet("pendingReleasesGU", $data));
    }
    
    public function daysOfDelayGU(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'DTPROCESSA', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);

        $data = $this->crudService->getFilteredDataSet('daysOfDelayGU', $conditions)->getRows();
		$response->addDataSet(new DataSet("daysOfDelayGU", $data));
    }
    
     public function productWithoutMovGU(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);
        
        $data = $this->crudService->getFilteredDataSet('productWithoutMovGU', $conditions)->getRows();
		$response->addDataSet(new DataSet("productWithoutMovGU", $data));
    }
    
    public function consumptionExpenseBudgetGU(Request\Filter $request, Response $response) {
        $filter = $request->getFilterCriteria()->getConditions();
        $params = ['CDFILIAL', 'DTPROCESSA', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);
        array_push($conditions, $filter[0]);

        $data = $this->crudService->getFilteredDataSet('consumptionExpenseBudgetGU', $conditions)->getRows();
		$response->addDataSet(new DataSet("consumptionExpenseBudgetGU", $data));
    }
    
    public function demonstrativeSummaryGU(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'DTPROCESSA', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);
        
        $data = $this->crudService->getFilteredDataSet('demonstrativeSummaryGU', $conditions)->getRows();
		$response->addDataSet(new DataSet("demonstrativeSummaryGU", $data));
    }
    
    public function costAnalysisGU(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);
        
        $data = $this->crudService->getFilteredDataSet('costAnalysisGU', $conditions)->getRows();
		$response->addDataSet(new DataSet("costAnalysisGU", $data));
    }
    
    public function puAnalysisDayGU(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);
        
        $data = $this->crudService->getFilteredDataSet('puAnalysisDayGU', $conditions)->getRows();
		$response->addDataSet(new DataSet("puAnalysisDayGU", $data));
    }
    
    public function inflationGU(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'DTPROCESSA', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);
        $filter = $request->getFilterCriteria()->getConditions();
        
        $data = $this->crudService->getFilteredDataSet('inflationGU', array_merge($conditions, $filter))->getRows();
		$response->addDataSet(new DataSet("inflationGU", $data));
    }
    
    public function workflowConsumptionExpenseGU(Request\Filter $request, Response $response) {
        $filter = $request->getFilterCriteria()->getConditions();
        $params = ['CDFILIAL', 'DTPROCESSA'];
        $conditions = $this->util->prepareConditions($params);
        array_push($conditions, $filter[0]);
        
        $data = $this->crudService->getFilteredDataSet('workflowConsumptionExpenseGU', $conditions)->getRows();
		$response->addDataSet(new DataSet("workflowConsumptionExpenseGU", $data));
    }
    
    public function periodBudgetGU(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'DTPROCESSA', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);
        
        $data = $this->crudService->getFilteredDataSet('periodBudgetGU', $conditions)->getRows();
		$response->addDataSet(new DataSet("periodBudgetGU", $data));
    }
    
    public function demonstrativeSummaryGridGU(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL','NRORG'];
        $conditions = $this->util->prepareConditions($params);
        // $nrlista = $this->util->insertLista($this->environment->getCdFilial());
        // array_push($conditions, array(
        //     "columnName" => "NRLISTA",
        //     "operator"   => '=',
        //     "value"      => $nrlista
        // ));
       
        $data = $this->crudService->getFilteredDataSet('demonstrativeSummaryGridGU', $conditions)->getRows();
        // $this->util->deleteLista($nrlista);
        $response->addDataSet(new DataSet("demonstrativeSummaryGridGU", $data));
    }
    
    public function todayDeliveries(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'DTPROCESSA', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);
        $data = $this->crudService->getFilteredDataSet('todayDeliveries', $conditions)->getRows();
		$response->addDataSet(new DataSet("todayDeliveries", $data));
    }
    
     public function productWithoutMovGrid(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);
        $filter = $request->getFilterCriteria()->getConditions();
        
        $data = $this->crudService->getFilteredDataSet('productWithoutMovGrid', array_merge($conditions, $filter))->getRows();
		$response->addDataSet(new DataSet("productWithoutMovGrid", $data));
    }
    
    public function consumBudgetGrid(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'DTPROCESSA', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);
        $filter = $request->getFilterCriteria()->getConditions();

        $data = $this->crudService->getFilteredDataSet('consumExpenBudgetGrid', array_merge($conditions, $filter))->getRows();
		$response->addDataSet(new DataSet("consumBudgetGrid", $data));
    }
    
    public function expenBudgetGrid(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'DTPROCESSA', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);
        $filter = $request->getFilterCriteria()->getConditions();

        $data = $this->crudService->getFilteredDataSet('consumExpenBudgetGrid', array_merge($conditions, $filter))->getRows();
		$response->addDataSet(new DataSet("expenBudgetGrid", $data));
    }
    
    public function inflationGrid(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'DTPROCESSA', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);
        $filter = $request->getFilterCriteria()->getConditions();
        
        $data = $this->crudService->getFilteredDataSet('inflationGU', array_merge($conditions, $filter))->getRows();
		$response->addDataSet(new DataSet("inflationGrid", $data));
    }
    
    public function costAnalysisGrid(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);
        
        $data = $this->crudService->getFilteredDataSet('costAnalysisGU', $conditions)->getRows();
		$response->addDataSet(new DataSet("costAnalysisGrid", $data));
    }
}